#include <intrinsics.h>

/* CPU֐wb_ */
#include "cpu_init.h"

/****************************************************************************
	CPUJ[h I{[hLED_
****************************************************************************/

/* VXeRg[̃WX^ */
#define SYS_SCS		((volatile unsigned int *)(0xE01FC1A0))

/* NbNĨWX^*/
#define CLKSRCSEL       ((volatile unsigned int *)(0xE01FC10C))
#define PCLKSEL0        ((volatile unsigned int *)(0xE01FC1A8))
#define PCLKSEL1        ((volatile unsigned int *)(0xE01FC1AC))

/* |[gRg[̃WX^ */
#define GPIO_PINSEL1	((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* FGPIORg[̃WX^ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))

/* 荞݃Rg[(VIC)̃WX^ */
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))
#define TIMER0_INT_BIT  (0x00000010)

/* Timer̃WX^ */
#define TIMER0_InterruptRegister    ((volatile unsigned int *)(0xE0004000))
#define TIMER0_TimerControlRegister ((volatile unsigned int *)(0xE0004004))
#define TIMER0_TimerCounter         ((volatile unsigned int *)(0xE0004008))
#define TIMER0_PrescaleRegister     ((volatile unsigned int *)(0xE000400C))
#define TIMER0_PrescaleCounter      ((volatile unsigned int *)(0xE0004010))
#define TIMER0_MatchControlRegister ((volatile unsigned int *)(0xE0004014))
#define TIMER0_MatchRegister0       ((volatile unsigned int *)(0xE0004018))

/* LED_鏈 */
void LED_ON() {
    *FGPIO_FIO1PIN=0x00000000; /* P1[18] '0'ɁiLED_j */
}

/* LED鏈 */
void LED_OFF() {
    *FGPIO_FIO1PIN=0x00040000; /* P1[18] '1'ɁiLEDj   */
}

/* IRQ 荞ݏ */
__irq __arm void IRQ_Handler()
{
    static int led = 0;

    if( led == 0 ) {
        led = 1;
        LED_ON();
    } else {
        led = 0;
        LED_OFF();
    }

    *TIMER0_InterruptRegister = 1; /* MC0NA */
}

/* main֐ */
int main(void)
{
    /* CPUŗL */
    CPU_Initialize();           /* CPU 72MHz */

    *SYS_SCS = *SYS_SCS | 1;    /* FGPIO Select            */

    *FGPIO_FIO1DIR =0x00040000;	/* P1[18] o͒[qɂ       */
    *FGPIO_FIO1MASK=0x00000000;	/* P1ɂ͈؃}XNȂ    */

    /* 荞݂Ə߂ē_悤LEDĂ     */
    LED_OFF();

    /* 荞ݎޑI (SĂ̊荞݂FIQł͂ȂIRQɂ)   */
    *VIC_IntSelect = 0;

    /* 0.5b1񊄂荞݂悤 Timer0̃p[^ݒ         */
    *TIMER0_PrescaleRegister     = 0x00000000;      /* vXP[  */
    *TIMER0_MatchRegister0       =    9000000;      /* MR0 = 18M/2 = 9M = 0.5b  */
    *TIMER0_MatchControlRegister = 0x00000003;      /* MatchTCNA & 荞 */

    /* VICɊ荞݋w        */
    *VIC_IntEnable = TIMER0_INT_BIT;

    /* CPUɊ荞݋w        */
    __enable_interrupt();

    /* ^C}X^[g                     */
    *TIMER0_TimerControlRegister = 1;

    /* [v(ł͉ȂB0.5bƂIRQ_Handler()֐Ăяo  */
    for(;;){
    }
}
